/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_PERCEPTIONBOUNDINGBOXARRAY_H
#define IMPL_TYPE_PERCEPTIONBOUNDINGBOXARRAY_H

#include "impl_type_uint64.h"
#include "impl_type_vector_perceptionboundingbox.h"

struct PerceptionBoundingBoxArray {
    ::UInt64 stamp_high{ 0U };
    ::UInt64 stamp_low{ 0U };
    ::vector_PerceptionBoundingBox boxes;

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(stamp_high);
        fun(stamp_low);
        fun(boxes);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(stamp_high);
        fun(stamp_low);
        fun(boxes);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("stamp_high", stamp_high);
        fun("stamp_low", stamp_low);
        fun("boxes", boxes);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("stamp_high", stamp_high);
        fun("stamp_low", stamp_low);
        fun("boxes", boxes);
    }

    friend bool operator==(const ::PerceptionBoundingBoxArray& lhs, const ::PerceptionBoundingBoxArray& rhs) noexcept
    {
        return (lhs.stamp_high == rhs.stamp_high) && (lhs.stamp_low == rhs.stamp_low) && (lhs.boxes == rhs.boxes);
    }
};


#endif // IMPL_TYPE_PERCEPTIONBOUNDINGBOXARRAY_H
